package com.ruoyi.project.business.service.quotation;

import cn.hutool.core.lang.Pair;
import com.baomidou.mybatisplus.extension.service.IService;
import com.github.pagehelper.PageInfo;
import com.ruoyi.project.business.domain.TbSalesDiscount;
import com.ruoyi.project.business.domain.TqQuotation;
import com.ruoyi.project.business.domain.bo.quotation.QuotationAddBO;
import com.ruoyi.project.business.domain.bo.quotation.QuotationContractBo;
import com.ruoyi.project.business.domain.bo.quotation.QuotationCopyBO;
import com.ruoyi.project.business.domain.bo.quotation.QuotationQueryBO;
import com.ruoyi.project.business.domain.vo.quotation.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Service接口
 *
 * @author ruoyi
 * @date 2024-05-10
 */
public interface ITqQuotationService extends IService<TqQuotation> {

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    public QuotationDetailVO selectTqQuotationById(Long id);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    public List<QuotationVO> selectTqQuotationList(QuotationQueryBO tqQuotation);

    /**
     * 新增【请填写功能名称】
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 结果
     */
    public void insertTqQuotation(QuotationAddBO quotationAddBO);

    void checkAreaElevatorCorrelation(Long areaId, List<Pair<Long, String>> elevatorList);

    /**
     * 修改【请填写功能名称】
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 结果
     */
    public void updateTqQuotation(QuotationAddBO tqQuotation);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键集合
     * @return 结果
     */
    public int deleteTqQuotationByIds(Long[] ids);

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    public int deleteTqQuotationById(Long id);

    void copyVersions(QuotationCopyBO copyBO);

    List<CivilQuotationVO> listByProjectId(Long projectId);

    QuotationPriceVO getPriceInfo(Long quotationId);

    TbSalesDiscount getSalesDiscountByQuotationId(Long quotationId);

    PageInfo<QuotationApprovalVO> listApproval();

    H5QuotationDetailVO detailApproval(Long id);

    TbSalesDiscount getSalesDiscountByFlow(Integer flowStatus);

    List<QuotationContractVo> getQuotation4Contract(QuotationContractBo quotationContractBo);

    void export(Long id);

    List<QuotationVO> selectTqQuotationListAll(QuotationQueryBO queryBO);
}
